# Test cases for Lab 5 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#------------------------------------------------------------------------------------------------

_target_list = [
   'temps', 'countletters', 'wordlen', 'linenums', 'airports', 'people',
   opts('movie', cases=[1,2,3,4]), opts('movie', cases=[5,6,7,8,9,10]),
   opts('viewers', cases=1), opts('viewers', cases=[2,3]),
]

#------------------------------------------------------------------------------------------------

_test_cases = {

   'temps':{
      1: ('', (), None, "F        C", "0    -17.8", "10    -12.2", "20     -6.7", "30     -1.1", "40      4.4",
          "50     10.0", "60     15.6", "70     21.1", "80     26.7", "90     32.2", "100     37.8"),
   },

   'countletters':{
      1: ('haunting.txt', (), None, "31 A's", "5 B's", "6 C's", "35 S's", "32 T's", "9 U's",
          "3 V's", "9 W's", ("1 X", "1 X's"), "12 Y's", "0 Z's"),
      2: ('huckfinn.txt', (), None, "35459 A's", "7144 B's", "7643 C's", "23177 D's", "47097 E's",
          "13058 W's", "355 X's", "9961 Y's", "182 Z's"),
      3: ('alice.txt', (), None, "8791 A's", "1475 B's", "2399 C's", "6500 S's", "10688 T's",
          "3468 U's", "846 V's", "2675 W's", "148 X's", "2264 Y's", "78 Z's"),
      4: ('moby.txt', (), None, "75566 A's", "16413 B's", "21755 C's", "62477 S's", "85524 T's",
          "25874 U's", "8344 V's", "21546 W's", "998 X's", "16417 Y's", "629 Z's"),
   },

   'wordlen':{
      1: ('haunting.txt', (), None, Lit('5.048')),
      2: ('alice.txt', (), None, ('4.384', Lit('4.383'))),
      3: ('huckfinn.txt', (), None, Lit('3.994')),
      4: ('moby.txt', (), None, Lit('4.651')),
   },

   'linenums':{
      1: ('haunting.txt', (), None,
          "1 :", "No live organism can continue for long to exist",
          "2 :", "sanely under conditions of absolute reality; even",
          "3 :", "larks and katydids are supposed, by some, to",
          "4 :", "dream.  Hill House, not sane, stood by itself",
          "5 :", "against its hills, holding darkness within; it had",
          "6 :", "stood so for eighty years and might stand for",
          "7 :", "eighty more.  Within, walls continued upright,",
          "8 :", "bricks met neatly, floors were firm, and doors",
          "9 :", "were sensibly shut; silence lay steadily against",
          "10 :", "the wood and stone of Hill House, and whatever",
          "11 :", "walked there, walked alone."),
   },

   'airports':{
      1: ('', (), None,
          Lit("ABQ Albuquerque, New Mexico\n" +
              "ATL Atlanta, Georgia\n" +
              "BNA Nashville, Tennessee\n" +
              "BOS Boston, Massachusetts\n" +
              "DCA Washington, D.C.\n" +
              "DEN Denver, Colorado\n" +
              "DFW Dallas/Fort Worth, Texas\n" +
              "DTW Detroit, Michigan\n" +
              "HOU Houston, Texas\n" +
              "JFK New York, New York\n" +
              "LAX Los Angeles, California\n" +
              "MIA Miami, Florida\n" +
              "MSP Minneapolis/St. Paul, Minnesota\n" +
              "MSY New Orleans, Louisiana\n" +
              "ORD Chicago, Illinois\n" +
              "PHL Philadelphia, Pennsylvania\n" +
              "PHX Phoenix, Arizona\n" +
              "PVD Providence, Rhode Island\n" +
              "RDU Raleigh/Durham, North Carolina\n" +
              "SEA Seattle, Washington\n" +
              "SFO San Francisco, California\n" +
              "STL St. Louis, Missouri\n" +
              "TPA Tampa, Florida\n")),
   },

   'people':{
      1: ('', (), None,
          Lit("Fred is 6 feet 1 inches tall and weighs 170.2 pounds (77.36 kg)\n" +
              "Susan is 5 feet 9 inches tall and weighs 155.3 pounds (70.59 kg)\n" +
              "Oliver is 4 feet 11 inches tall and weighs 143.5 pounds (65.23 kg)\n" +
              "Nancy is 6 feet 3 inches tall and weighs 112.0 pounds (50.91 kg)\n" +
              "Roger is 5 feet 5 inches tall and weighs 198.9 pounds (90.41 kg)\n" +
              "Tom is 9 feet 11 inches tall and weighs 425.1 pounds (193.23 kg)\n" +
              "Laura is 5 feet 2 inches tall and weighs 139.2 pounds (63.27 kg)\n")),
   },

   'movie':{
      1: ('1', (), None, 'Toy Story (1995)'),
      2: ('10', (), None, 'Richard III (1995)'),
      3: ('300', (), None, 'Air Force One (1997)'),
      4: ('1682', (), None, 'Scream of Stone (Schrei aus Stein) (1991)'),
      5: ('50', (), None, Lit('Star Wars (1977)'),
          ('4.4', '4.36', '4.358'), ('583 reviews', '583 ratings')),
      6: ('1', (), None, Lit('Toy Story (1995)'),
          ('3.9', '3.88', '3.878'), ('452 reviews', '452 ratings')),
      7: ('200', (), None, Lit('The Shining (1980)'),
          ('3.8', '3.83', '3.825'), ('206 reviews', '206 ratings')),
      8: ('400', (), None, Lit('The Little Rascals (1994)'),
          ('2.7', '2.72', '2.722'), ('18 reviews', '18 ratings')),
      9: ('600', (), None, Lit("Daniel Defoe's Robinson Crusoe (1996)"),
          ('3.0', '3.00', '3.000', '3'), ('2 reviews', '2 ratings')),
      10: ('999', (), None, Lit('Clean Slate (1994)'),
           ('2.8', '2.80', '2.800'), ('10 reviews', '10 ratings')),
   },

   'viewers':{
      1: ('', (), None, ('Average viewer age is', 'Average age is'), (Lit('34.05'), '34.1', '34'), 'years old'),
      2: ('', (), None, ('Youngest viewer is 7', 'Youngest is 7')),
      3: ('', (), None, ('Oldest viewer is 73', 'Oldest is 73')),
   },

}
